std::move_iterator::operator*,->(3)

NAME
std::move_iterator::operator*,-> - std::move_iterator::operator*,->

Synopsis
   reference operator* () const; (since C++11)
                        (until C++17)
   constexpr reference operator* () const; (since C++17)
   pointer operator->() const; (1) (since C++11)
                        (2) (until C++17)
   constexpr pointer operator->() const; (since C++17)
                        (deprecated in C++20)
   Returns a rvalue-reference or pointer to the current element.
   1) Equivalent to
   static_cast<reference>(*base())
   (until C++20)
   ranges::iter_move(base())
   (since C++20).
   2) Equivalent to base().

Parameters
   (none)

Return value
   1) Rvalue-reference to the current element or its copy.
   2) Copy of the underlying iterator. A pointer to the current element is eventually
   returned if -> is directly used.

Notes
   Note that (2) eventually returns a pointer if -> is directly used. When
   dereferencing a pointer the returned value is an lvalue. This may lead to unintended
   behavior.

Example
// Run this code
 #include <iomanip>
 #include <iostream>
 #include <iterator>
 #include <string>
 #include <vector>
 void print(auto rem, auto const& v) {
     for (std::cout << rem; auto const& e : v)
         std::cout << quoted(e) << ' ';
     std::cout << '\n';
 }
 int main()
 {
     std::vector<std::string> p{"alpha", "beta", "gamma", "delta"}, q;
     print("1) p: ", p);
     for (std::move_iterator it{p.begin()}, end{p.end()}; it != end; ++it) {
         it->push_back('!'); // calls -> string::push_back(char)
         q.emplace_back( *it );
     }
     print("2) p: ", p);
     print("3) q: ", q);
     std::vector v{1,2,3};
     std::move_iterator it{v.begin()};
     // *it = 13; // error: using rvalue as lvalue
 }

Output:
 1) p: "alpha" "beta" "gamma" "delta"
 2) p: "" "" "" ""
 3) q: "alpha!" "beta!" "gamma!" "delta!"
  Defect reports
   The following behavior-changing defect reports were applied retroactively to
   previously published C++ standards.
      DR Applied to Behavior as published Correct behavior
                       dereferencing a move_iterator could return a
   LWG 2106 C++11 dangling reference returns the object
                       if the dereferencing the underlying iterator instead
                       returns a prvalue

See also
   operator[] accesses an element by index
   (C++11) (public member function)